#developer pls change here
rails_root  = "/home/nccu/NCCU/"  #keep this blank when development

development_uid = 'kaito' #when dev
development_gid = 'staff' #when dev

#rails_env   =   "developement"
rails_env   =   "production"

development_rails_root  =  File.expand_path("..",File.dirname(__FILE__))
#rails_root =  (rails_env == 'production' )? production_rails_root : development_rails_root 

  God.watch do |w|
    w.dir        = rails_root
    w.name    = "resque-scheduler"
    w.group   = 'resque'
    w.interval = 30.seconds
    w.env       = {"QUEUE"=>"critical,high,low", "RAILS_ENV"=>rails_env}
    w.start     = "rake -f #{rails_root}/Rakefile resque:scheduler RAILS_ENV=#{rails_env}"

    w.uid = (rails_env == 'production' )? "root" : development_uid
    w.gid = (rails_env == 'production' )? "root" : development_gid
  
     w.log = (rails_env == 'production' )? "/var/log/#{w.name}.log":"#{rails_root}/log/#{w.name}.log"

    # restart if memory gets too high
    w.transition(:up, :restart) do |on|
      on.condition(:memory_usage) do |c|
        c.above = 350.megabytes
        c.times = 2
      end
    end

    # determine the state on startup
    w.transition(:init, { true => :up, false => :start }) do |on|
      on.condition(:process_running) do |c|
        c.running = true
      end
    end

    # determine when process has finished starting
    w.transition([:start, :restart], :up) do |on|
      on.condition(:process_running) do |c|
        c.running = true
        c.interval = 5.seconds
      end

      # failsafe
      on.condition(:tries) do |c|
        c.times = 5
        c.transition = :start
        c.interval = 5.seconds
      end
    end

    # start if process is not running
    w.transition(:up, :start) do |on|
      on.condition(:process_running) do |c|
        c.running = false
      end
    end
  end

